/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/ia64/ia64.md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tree.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "toplev.h"
#include "reload.h"
#include "regs.h"

int
call_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (mode == VOIDmode || GET_MODE (op) == mode)) || (register_operand (op, mode));
}

int
symbolic_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == CONST || GET_CODE (op) == LABEL_REF;
}

int
function_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (SYMBOL_REF_FUNCTION_P (op))) && (mode == VOIDmode || GET_MODE (op) == mode);
}

static inline int
got_symbolic_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LABEL_REF:
      return true;

    case SYMBOL_REF:
      /* This sort of load should not be used for things in sdata.  */
      return !SYMBOL_REF_SMALL_ADDR_P (op);

    case CONST:
      /* Accept only (plus (symbol_ref) (const_int)).  */
      op = XEXP (op, 0);
      if (GET_CODE (op) != PLUS
	  || GET_CODE (XEXP (op, 0)) != SYMBOL_REF
          || GET_CODE (XEXP (op, 1)) != CONST_INT)
        return false;

      /* Ok if we're not using GOT entries at all.  */
      if (TARGET_NO_PIC || TARGET_AUTO_PIC)
        return true;

      /* The low 14 bits of the constant have been forced to zero
	 by ia64_expand_load_address, so that we do not use up so
	 many GOT entries.  Prevent cse from undoing this.  */
      op = XEXP (op, 1);
      return (INTVAL (op) & 0x3fff) == 0;

    default:
      abort ();
    }
}

int
got_symbolic_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((symbolic_operand (op, mode)) && (got_symbolic_operand_1 (op, mode))) && (mode == VOIDmode || GET_MODE (op) == mode);
}

static inline int
sdata_symbolic_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  HOST_WIDE_INT offset = 0, size = 0;

  switch (GET_CODE (op))
    {
    case CONST:
      op = XEXP (op, 0);
      if (GET_CODE (op) != PLUS
	  || GET_CODE (XEXP (op, 0)) != SYMBOL_REF
	  || GET_CODE (XEXP (op, 1)) != CONST_INT)
	return false;
      offset = INTVAL (XEXP (op, 1));
      op = XEXP (op, 0);
      /* FALLTHRU */

    case SYMBOL_REF:
      if (CONSTANT_POOL_ADDRESS_P (op))
	{
	  size = GET_MODE_SIZE (get_pool_mode (op));
	  if (size > ia64_section_threshold)
	    return false;
	}
      else
	{
	  tree t;

	  if (!SYMBOL_REF_LOCAL_P (op) || !SYMBOL_REF_SMALL_P (op))
	    return false;

	  /* Note that in addition to DECLs, we can get various forms
	     of constants here.  */
	  t = SYMBOL_REF_DECL (op);
	  if (DECL_P (t))
	    t = DECL_SIZE_UNIT (t);
	  else
	    t = TYPE_SIZE_UNIT (TREE_TYPE (t));
	  if (t && host_integerp (t, 0))
	    {
	      size = tree_low_cst (t, 0);
	      if (size < 0)
		size = 0;
	    }
	}

      /* Deny the stupid user trick of addressing outside the object.  Such
	 things quickly result in GPREL22 relocation overflows.  Of course,
	 they're also highly undefined.  From a pure pedant's point of view
	 they deserve a slap on the wrist (such as provided by a relocation
	 overflow), but that just leads to bugzilla noise.  */
      return (offset >= 0 && offset <= size);

    default:
      abort ();
    }
}

int
sdata_symbolic_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == CONST) && (sdata_symbolic_operand_1 (op, mode))) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
destination_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (nonimmediate_operand (op, mode)) && (GET_CODE (op) != MEM
		    || GET_CODE (XEXP (op, 0)) != POST_MODIFY
		    || GET_CODE (XEXP (XEXP (XEXP (op, 0), 1), 1)) != REG);
}

int
not_postinc_memory_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (memory_operand (op, mode)) && (GET_RTX_CLASS (GET_CODE (XEXP (op, 0))) != RTX_AUTOINC);
}

int
move_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (general_operand (op, mode)) && (!(GET_CODE (op) == SYMBOL_REF && SYMBOL_REF_TLS_MODEL (op)));
}

static inline int
gr_register_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  unsigned int regno;
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);

  regno = REGNO (op);
  return (regno >= FIRST_PSEUDO_REGISTER || GENERAL_REGNO_P (regno));
}

int
gr_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (gr_register_operand_1 (op, mode));
}

static inline int
fr_register_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  unsigned int regno;
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);

  regno = REGNO (op);
  return (regno >= FIRST_PSEUDO_REGISTER || FR_REGNO_P (regno));
}

int
fr_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (fr_register_operand_1 (op, mode));
}

static inline int
grfr_register_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  unsigned int regno;
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);

  regno = REGNO (op);
  return (regno >= FIRST_PSEUDO_REGISTER
	  || GENERAL_REGNO_P (regno)
	  || FR_REGNO_P (regno));
}

int
grfr_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (grfr_register_operand_1 (op, mode));
}

static inline int
gr_nonimmediate_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  unsigned int regno;

  if (GET_CODE (op) == MEM)
    return true;
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);

  regno = REGNO (op);
  return (regno >= FIRST_PSEUDO_REGISTER || GENERAL_REGNO_P (regno));
}

int
gr_nonimmediate_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (nonimmediate_operand (op, mode)) && (gr_nonimmediate_operand_1 (op, mode));
}

static inline int
fr_nonimmediate_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  unsigned int regno;

  if (GET_CODE (op) == MEM)
    return true;
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);

  regno = REGNO (op);
  return (regno >= FIRST_PSEUDO_REGISTER || FR_REGNO_P (regno));
}

int
fr_nonimmediate_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (nonimmediate_operand (op, mode)) && (fr_nonimmediate_operand_1 (op, mode));
}

static inline int
grfr_nonimmediate_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  unsigned int regno;

  if (GET_CODE (op) == MEM)
    return true;
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);

  regno = REGNO (op);
  return (regno >= FIRST_PSEUDO_REGISTER
	  || GENERAL_REGNO_P (regno)
	  || FR_REGNO_P (regno));
}

int
grfr_nonimmediate_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (nonimmediate_operand (op, mode)) && (grfr_nonimmediate_operand_1 (op, mode));
}

int
gr_reg_or_0_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (op == const0_rtx));
}

int
gr_reg_or_5bit_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (INTVAL (op) >= 0 && INTVAL (op) < 32));
}

int
gr_reg_or_6bit_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_M (INTVAL (op))));
}

int
gr_reg_or_8bit_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_K (INTVAL (op))));
}

int
grfr_reg_or_8bit_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (grfr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_K (INTVAL (op))));
}

int
gr_reg_or_8bit_adjusted_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_L (INTVAL (op))));
}

int
gr_reg_or_8bit_and_adjusted_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_K (INTVAL (op))
                         && CONST_OK_FOR_L (INTVAL (op))));
}

int
gr_reg_or_14bit_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_I (INTVAL (op))));
}

int
gr_reg_or_22bit_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (gr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_J (INTVAL (op))));
}

int
dshift_count_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (INTVAL (op) >= 0 && INTVAL (op) < 128);
}

int
shift_count_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (CONST_OK_FOR_M (INTVAL (op)));
}

int
shift_32bit_count_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (INTVAL (op) >= 0 && INTVAL (op) < 32);
}

int
shladd_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (INTVAL (op) == 2 || INTVAL (op) == 4 ||
	            INTVAL (op) == 8 || INTVAL (op) == 16);
}

int
fetchadd_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (INTVAL (op) == -16 || INTVAL (op) == -8 ||
                    INTVAL (op) == -4  || INTVAL (op) == -1 ||
                    INTVAL (op) == 1   || INTVAL (op) == 4  ||
                    INTVAL (op) == 8   || INTVAL (op) == 16);
}

int
fr_reg_or_fp01_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (fr_register_operand (op, mode)) || ((GET_CODE (op) == CONST_DOUBLE) && (CONST_DOUBLE_OK_FOR_G (op)));
}

int
xfreg_or_fp01_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (fr_reg_or_fp01_operand (op, mode)) && (!(GET_CODE (op) == SUBREG));
}

int
normal_comparison_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == EQ || GET_CODE (op) == NE || GET_CODE (op) == GT || GET_CODE (op) == LE || GET_CODE (op) == GTU || GET_CODE (op) == LEU) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
adjusted_comparison_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == LT || GET_CODE (op) == GE || GET_CODE (op) == LTU || GET_CODE (op) == GEU) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
signed_inequality_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == GE || GET_CODE (op) == GT || GET_CODE (op) == LE || GET_CODE (op) == LT) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
predicate_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == EQ || GET_CODE (op) == NE) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
condop_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PLUS || GET_CODE (op) == MINUS || GET_CODE (op) == IOR || GET_CODE (op) == XOR || GET_CODE (op) == AND) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
ar_lc_reg_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (mode == DImode && REGNO (op) == AR_LC_REGNUM)) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
ar_ccv_reg_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (mode == DImode && REGNO (op) == AR_CCV_REGNUM)) && (mode == VOIDmode || GET_MODE (op) == mode);
}

int
ar_pfs_reg_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (mode == DImode && REGNO (op) == AR_PFS_REGNUM)) && (mode == VOIDmode || GET_MODE (op) == mode);
}

static inline int
basereg_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);
  return REG_POINTER (op);
}

int
basereg_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (basereg_operand_1 (op, mode));
}

